'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ActionCable = require('./action-cable');

var LiveReloader = function () {
  function LiveReloader() {
    _classCallCheck(this, LiveReloader);
  }

  _createClass(LiveReloader, [{
    key: 'buildFreshUrl',
    value: function buildFreshUrl(url) {
      var date = Math.round(Date.now() / 1000).toString();
      url = url.replace(/(\&|\\?)version=\d*/, '');

      return '' + url + (url.indexOf('?') >= 0 ? '&' : '?') + 'version=' + date;
    }
  }, {
    key: 'cssReload',
    value: function cssReload() {
      var _this = this;

      var reloadableLinkElements = window.top.document.querySelectorAll('link[rel=stylesheet]:not([data-no-reload]):not([data-pending-removal])');

      [].slice.call(reloadableLinkElements).filter(function (link) {
        return link.href;
      }).forEach(function (link) {
        return link.href = _this.buildFreshUrl(link.href);
      });

      // Repaint
      setTimeout(function () {
        document.body.offsetHeight;
      }, 25);
    }
  }, {
    key: 'pageReload',
    value: function pageReload() {
      window.top.location.reload();
    }
  }, {
    key: 'init',
    value: function init() {
      var host = arguments.length <= 0 || arguments[0] === undefined ? "localhost" : arguments[0];
      var port = arguments.length <= 1 || arguments[1] === undefined ? 3000 : arguments[1];

      var reloaders = {
        js: this.pageReload.bind(this),
        css: this.cssReload.bind(this),
        html: this.pageReload.bind(this)
      };

      document.addEventListener('DOMContentLoaded', function () {
        var Breakfast = window.Breakfast || {};

        if (Breakfast.liveReload) {
          var reloadChannel = 'Breakfast::LiveReloadChannel';

          Breakfast.cable = ActionCable.createConsumer('ws://' + host + ':' + port + '/cable');
          Breakfast.channel = Breakfast.cable.subscriptions.create(reloadChannel, {
            received: function received(data) {
              var reloader = reloaders[data.extension];
              reloader();
            }
          });
        }
      });
    }
  }]);

  return LiveReloader;
}();

module.exports = LiveReloader;